MantisBT
Mantis Bug Tracker Workflow

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0025588Community[OCCT] OCCT:Meshpublic2014-12-10 16:292018-11-17 23:23
Reporterdrazmyslovich 
Assigned Todrazmyslovich 
PrioritynormalSeverityminor 
StatusfeedbackResolutionopen 
PlatformWindowsOSVC++ 2010OS Version64 bit
Product Version[OCCT] 6.8.0 
Target Version[OCCT] 7.4.0*Fixed in Version 
Summary0025588: BRepMesh_ShapeTool::FindUV check for 2d points to be the same is inconsistent with ShapeAnalysis_Wire::CheckLacking
DescriptionThe current ShapeTool implementation checks 2d points to be same/different using either the distance between the corresponding 3d points or the absolute difference 2d coordinates compared with the surface size. Such check is inconsistent with ShapeAnalysis_Wire::CheckLacking function. This inconsistency results in OpenWire flag, while CheckLacking doesn't report any problems.
Steps To Reproduce# Template to check attached files

restore <face_name>.brep result

tclean result
set log [incmesh result 0.01]

checktrinfo result -tri 0 -nod 0

regexp {Meshing statuses: (\w+)} $log str status
if [string match Failure $status] {
  puts "OK: Failure flag is returned"
} else {
  puts "Error: unexpected flag ($status)"
}

TagsNo tags attached.
Test case number
Attached Fileszip file icon 25588.zip (962,204 bytes) 2014-12-17 15:11

- Relationships
related to 0023111verifiedbugmaster Open CASCADE Incorrect mesh 

-  Notes
(0035270)
git (administrator)
2014-12-10 16:31

Branch CR25588 has been created by drazmyslovich.

SHA-1: 1a48f67651c699a53b3daddcae8d5462eeed4f73


Detailed log of new commits:

Author: razmyslovich
Date: Wed Dec 10 14:30:42 2014 +0100

    0025588: fix inconsistency in 2d coordinates equality check
(0035271)
drazmyslovich (developer)
2014-12-10 16:32

The fix is committed, please, review
(0035273)
oan (developer)
2014-12-10 16:44

Dear Dima,

thank you for the fix! Could you please also provide a test case or problematic shape/face using which the problem can be reproduced?
(0035464)
drazmyslovich (developer)
2014-12-17 15:16

Dear Oleg, I've attached zip file with 32 failing faces. For all these faces the classifier original returns the status OpenWire, while with the provided fix the mesher ends up with too fee vertices status, since all these faces are small and contain only 2 edges... The problem of too few vertices can be solved by decreasing the deflection iteratively like for self-intersected wires. Additionally in the zip file you will find Pulso 1 Main model from grabCAD, which is actually a regression of my fix. So my fix isn't good enough in order to cover both cases... Regards, Dima
(0040070)
abv (manager)
2015-04-21 08:41

I have checked the patch on current master (6.9.0.beta1), it produces 16 regressions (on 4 models) and 5 improvements (on 2 models):

Failed
mesh standard_incmesh J4 S8 V4 W5
mesh standard_incmesh_parallel J4 S8 V4 W5
mesh standard_mesh J4 S8 V4 W5
mesh standard_shading J4 S8 V4 W5
Improvements
bugs modalg_2 bug287
mesh standard_incmesh C9
mesh standard_incmesh_parallel C9
mesh standard_mesh C9
mesh standard_shading C9
(0080634)
nbv (developer)
2018-11-02 15:41

Currently described algorithm is not actual. So, there is no point in any fix. The issue can be closed.
(0080645)
drazmyslovich (developer)
2018-11-02 16:29

I'm not quite sure, what have you meant by the last comment, but ShapeAnalysis_Wire::CheckLacking is still different from BRepMesh_ShapeTool::FindUV in the way these functions evaluate the result, which causes the described problem - no lacking, but an open wire.
(0080647)
nbv (developer)
2018-11-02 16:40

Dear drazmyslovich,

Next week the fixes #26106, #30008, 0030305 and 0030322 will be integrated. As result, architecture of BRepMesh algorithm will be changed significantly.

As result BRepMesh_ShapeTool::FindUV(...) method will be vanished from OCCT.

So, please just clone MASTER version next week (when it will be pushed) and check your tests on new mesh. In case of any problems, please create new corresponding issue.
(0080649)
drazmyslovich (developer)
2018-11-02 16:55

Dear nbv,
thank you for the explanation. Maybe, in this case also other issues created once by me do not make some sense anymore. Particularly, 0025044, 0025589 and 0025022
(0080653)
msv (developer)
2018-11-02 17:55

Dear Dmitry, please check the bug state after integration of the fix for #26106.
(0080656)
oan (developer)
2018-11-02 17:59

Hello Dima,

All of these issues are still important, despite of the current state of BRepMesh. Probably, some problems are handled more correctly, but anyway they should not be closed yet, without proper checks.

As for current issue, FindUV functionality has been modified so it has became more complicated and thus changed its name and behavior.

We also waiting for 0025113 and thanks for 0029715.
The last one is included in the updated component.

Best regards.
(0081138)
oan (developer)
2018-11-17 23:23

Faces from the attached archive represent cases of open wires where gap is covered by tolerance. These ones should result in closed discrete contours of null area formed by two straight links causing error of meshing algorithm (by default).

However, all of them can be meshed using more fair angular tolerance producing several points along the border edges via

incmesh a 0.1 -a 5

Model "2.stp" is meshed via vdisplay without errors according to tricheck command.

- Issue History
Date Modified Username Field Change
2014-12-10 16:29 drazmyslovich New Issue
2014-12-10 16:29 drazmyslovich Assigned To => oan
2014-12-10 16:31 git Note Added: 0035270
2014-12-10 16:32 drazmyslovich Note Added: 0035271
2014-12-10 16:32 drazmyslovich Status new => resolved
2014-12-10 16:32 drazmyslovich Steps to Reproduce Updated View Revisions
2014-12-10 16:44 oan Note Added: 0035273
2014-12-10 16:44 oan Assigned To oan => drazmyslovich
2014-12-10 16:44 oan Status resolved => feedback
2014-12-17 15:11 drazmyslovich File Added: 25588.zip
2014-12-17 15:16 drazmyslovich Note Added: 0035464
2014-12-17 15:16 drazmyslovich Assigned To drazmyslovich => oan
2014-12-17 15:16 drazmyslovich Status feedback => resolved
2014-12-17 15:16 drazmyslovich Steps to Reproduce Updated View Revisions
2014-12-23 15:59 oan Relationship added parent of 0025628
2014-12-23 15:59 oan Relationship deleted parent of 0025628
2014-12-23 15:59 oan Relationship added child of 0025628
2014-12-23 16:06 oan Relationship added related to 0023111
2015-04-21 08:41 abv Note Added: 0040070
2015-04-21 08:41 abv Status resolved => assigned
2015-04-21 08:41 abv Target Version 6.9.0 => 7.1.0
2016-02-16 10:23 oan Relationship added child of 0027158
2016-02-16 12:27 oan Steps to Reproduce Updated View Revisions
2016-10-25 17:42 oan Relationship added related to 0026106
2016-10-25 17:42 oan Target Version 7.1.0 => 7.2.0
2017-07-20 12:43 oan Target Version 7.2.0 => 7.3.0
2018-02-25 21:09 abv Target Version 7.3.0 => 7.4.0*
2018-11-02 15:41 nbv Note Added: 0080634
2018-11-02 15:42 nbv Assigned To oan => msv
2018-11-02 15:42 nbv Status assigned => feedback
2018-11-02 16:29 drazmyslovich Note Added: 0080645
2018-11-02 16:40 nbv Note Added: 0080647
2018-11-02 16:55 drazmyslovich Note Added: 0080649
2018-11-02 17:55 msv Note Added: 0080653
2018-11-02 17:55 msv Assigned To msv => drazmyslovich
2018-11-02 17:59 oan Note Added: 0080656
2018-11-17 23:23 oan Note Added: 0081138


Copyright © 2000 - 2018 MantisBT Team
Powered by Mantis Bugtracker